> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Group Members

> Group Members — CometChat documentation.

## Overview

`CometChatGroupMembers` is a [Component](/ui-kit/react/v4/components-overview#components) that displays all users added or invited to a group, granting them access to group discussions, shared content, and collaborative features. Group members can communicate in real-time via messaging, voice and video calls, and other activities. They can interact, share files, and join calls based on group permissions set by the administrator or owner.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/v4EbHQCGZ54oJcmr/images/5b095cf9-group_members_overview_web_screens-ed7e2c8f329a2681e1dd06e1d9700139.png?fit=max&auto=format&n=v4EbHQCGZ54oJcmr&q=85&s=63c1099094029c236ac8bed6ab46eb15" width="3600" height="2400" data-path="images/5b095cf9-group_members_overview_web_screens-ed7e2c8f329a2681e1dd06e1d9700139.png" />
</Frame>

***

## Usage

### Integration

The following code snippet illustrates how you can directly incorporate the Group Members component into your Application.

<Tabs>
  <Tab title="GroupMembersDemo.tsx">
    ```typescript theme={null}

    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { CometChatGroupMembers } from '@cometchat/chat-uikit-react'
    import React from 'react'

    const GroupMembersDemo = () => {

        const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

        React.useEffect(() => {
            CometChat.getGroup("uid").then((group) => {
                setChatGroup(group);
            })
        }, []);
        return (
            <>
                {
                    chatGroup &&
                    <CometChatGroupMembers
                        group={chatGroup}
                    />
                }
            </>
        )
    }

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="App.tsx">
    ```typescript theme={null}
    import { GroupMembersDemo } from "./GroupMembersDemo";

    export default function App() {
      return (
        <div className="App">
          <GroupMembersDemo />
        </div>
      );
    }
    ```
  </Tab>
</Tabs>

***

### Actions

[Actions](/ui-kit/react/v4/components-overview#actions) dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.

#### 1. onSelect

The `onSelect` action is activated when you select the done icon while in selection mode. This returns a list of all the group members that you have selected.

This action does not come with any predefined behavior. However, you have the flexibility to override this event and tailor it to suit your needs using the following code snippet.

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupMembers,
      SelectionMode,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnSelect(
        groupMembers: CometChat.GroupMember,
        selected: boolean
      ): void {
        console.log(groupMembers);
        //your custom onSelect actions
      }
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              selectionMode={SelectionMode.multiple}
              onSelect={handleOnSelect}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupMembers,
      SelectionMode,
    } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      function handleOnSelect(groupMembers, selected) {
        console.log(groupMembers);
        // Your custom onSelect actions
      }

      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              selectionMode={SelectionMode.multiple}
              onSelect={handleOnSelect}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

#### 2. onItemClick

The `onItemClick` event is activated when you click on the Group Members List item. This action does not come with any predefined behavior. However, you have the flexibility to override this event and tailor it to suit your needs using the following code snippet.

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnItemClick(groupMembers: CometChat.GroupMember): void {
        console.log(groupMembers, "your custom on item click action");
      }
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              onItemClick={handleOnItemClick}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      function handleOnItemClick(groupMembers) {
        console.log(groupMembers, "your custom on item click action");
      }

      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              onItemClick={handleOnItemClick}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

#### 3. onBack

`OnBack` is triggered when you click on the back button of the Group Members component. You can override this action using the following code snippet.

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnBack() {
        console.log("your custom on back action");
      }
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers group={chatGroup} onBack={handleOnBack} />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      function handleOnBack() {
        console.log("your custom on back action");
      }

      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers group={chatGroup} onBack={handleOnBack} />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

#### 4. onClose

`onClose` is triggered when you click on the close button of the Group Members component. You can override this action using the following code snippet.

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnClose(): void {
        console.log("Your custom on close actions");
      }
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers group={chatGroup} onClose={handleOnClose} />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      function handleOnClose() {
        console.log("Your custom on close actions");
      }

      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers group={chatGroup} onClose={handleOnClose} />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

#### 5. onEmpty

This action allows you to specify a callback function to be executed when a certain condition, typically the absence of data or content, is met within the component or element.

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnEmpty(): void {
        console.log("your custom on empty actions");
      }
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers group={chatGroup} onEmpty={handleOnEmpty} />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      function handleOnEmpty() {
        console.log("your custom on empty actions");
      }

      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers group={chatGroup} onEmpty={handleOnEmpty} />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

#### 6. onError

This action doesn't change the behavior of the component but rather listens for any errors that occur in the Group Members component.

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnError(error: CometChat.CometChatException): void {
        //Your Custom on error actions
      }
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers group={chatGroup} onEmpty={handleOnEmpty} />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnError(error) {
        //Your Custom on error actions
      }

      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers group={chatGroup} onEmpty={handleOnEmpty} />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

***

### Filters

**Filters** allow you to customize the data displayed in a list within a Component. You can filter the list based on your specific criteria, allowing for a more customized. Filters can be applied using RequestBuilders of Chat SDK.

#### 1. GroupMembersRequestBuilder

The [GroupMembersRequestBuilder](/sdk/javascript/retrieve-group-members) enables you to filter and customize the group members list based on available parameters in GroupMembersRequestBuilder. This feature allows you to create more specific and targeted queries when fetching groups. The following are the parameters available in [GroupMembersRequestBuilder](/sdk/javascript/retrieve-group-members)

| Methods              | Type           | Description                                                                                       |
| -------------------- | -------------- | ------------------------------------------------------------------------------------------------- |
| **setLimit**         | number         | sets the number of group members that can be fetched in a single request, suitable for pagination |
| **setSearchKeyword** | String         | used for fetching group members matching the passed string                                        |
| **setScopes**        | Array\<String> | used for fetching group members based on multiple scopes                                          |

**Example**

In the example below, we are applying a filter to the Group Members by setting the limit to two and setting the scope to show only admin and moderator.

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              groupMemberRequestBuilder={new CometChat.GroupMembersRequestBuilder(
                "guid"
              )
                .setLimit(2)
                .setScopes(["admin", "moderator"])}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              groupMemberRequestBuilder={new CometChat.GroupMembersRequestBuilder(
                "uid"
              )
                .setLimit(2)
                .setScopes(["admin", "moderator"])}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

#### 2. SearchRequestBuilder

The SearchRequestBuilder uses [GroupMembersRequestBuilder](/sdk/javascript/retrieve-group-members) enables you to filter and customize the search list based on available parameters in GroupMembersRequestBuilder. This feature allows you to keep uniformity between the displayed Group Members List and searched Group Members List.

**Example**

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("guid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              searchRequestBuilder={new CometChat.GroupMembersRequestBuilder("guid")
                .setLimit(2)
                .setSearchKeyword("**")}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("guid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              searchRequestBuilder={new CometChat.GroupMembersRequestBuilder(
                "guid"
              ).setLimit(2)}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

***

### Events

[Events](/ui-kit/react/v4/components-overview#events) are emitted by a `Component`. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed.

Events emitted by the Group Members component is as follows.

| Event                         | Description                                                       |
| ----------------------------- | ----------------------------------------------------------------- |
| **ccGroupMemberBanned**       | Triggers when the group member banned from the group successfully |
| **ccGroupMemberKicked**       | Triggers when the group member kicked from the group successfully |
| **ccGroupMemberScopeChanged** | Triggers when the group member scope is changed in the group      |

<Tabs>
  <Tab title="Add Listener">
    ```javascript theme={null}
    const ccGroupMemberBanned = CometChatGroupEvents.ccGroupMemberBanned.subscribe(
      (item: IGroupMemberKickedBanned) => {
        //Your Code
      }
    );

    const ccGroupMemberKicked = CometChatGroupEvents.ccGroupMemberKicked.subscribe(
      (item: IGroupMemberKickedBanned) => {
        //Your Code
      }
    );

    const ccGroupMemberScopeChanged =
      CometChatGroupEvents.ccGroupMemberScopeChanged.subscribe(
        (item: IGroupMemberScopeChanged) => {
          //Your Code
        }
      );
    ```
  </Tab>
</Tabs>

***

<Tabs>
  <Tab title="Remove Listener">
    ```javascript theme={null}
    ccGroupMemberBanned?.unsubscribe();

    ccGroupMemberKicked?.unsubscribe();

    ccGroupMemberScopeChanged?.unsubscribe();
    ```
  </Tab>
</Tabs>

***

## Customization

To fit your app's design requirements, you can customize the appearance of the Group Members component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

### Style

Using **Style** you can **customize** the look and feel of the component in your app, These parameters typically control elements such as the **color**, **size**, **shape**, and **fonts** used within the component.

#### 1. GroupMembers Style

You can set the `GroupMembersStyle` to the Group Members Component to customize the styling.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Q-VZaihy61fy3D_G/images/2097412c-group_members_style_web_screens-bea9be2e9c7162f28391b74c514a8b08.png?fit=max&auto=format&n=Q-VZaihy61fy3D_G&q=85&s=1584af9cc1a7949a7d9bd7f3d5bb8aeb" width="3600" height="2400" data-path="images/2097412c-group_members_style_web_screens-bea9be2e9c7162f28391b74c514a8b08.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupMembers,
      GroupMembersStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const groupMembersStyle = new GroupMembersStyle({
        background: "#b17efc",
        searchPlaceholderTextColor: "#ffffff",
        titleTextColor: "#000000",
        searchBackground: "#5718b5",
      });
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              groupMembersStyle={groupMembersStyle}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupMembers,
      GroupMembersStyle,
    } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const groupMembersStyle = new GroupMembersStyle({
        background: "#b17efc",
        searchPlaceholderTextColor: "#ffffff",
        titleTextColor: "#000000",
        searchBackground: "#5718b5",
      });
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              groupMembersStyle={groupMembersStyle}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

List of properties exposed by GroupMembersStyle:

| Property                        | Description                          | Code                                    |
| ------------------------------- | ------------------------------------ | --------------------------------------- |
| **border**                      | Used to set border                   | `border?: string,`                      |
| **borderRadius**                | Used to set border radius            | `borderRadius?: string;`                |
| **background**                  | Used to set background colour        | `background?: string;`                  |
| **height**                      | Used to set height                   | `height?: string;`                      |
| **width**                       | Used to set width                    | `width?: string;`                       |
| **titleTextFont**               | Used to set title text font          | `titleTextFont?: string,`               |
| **titleTextColor**              | Used to set title text color         | `titleTextColor?: string;`              |
| **searchPlaceholderTextFont**   | Used to set search placeholder font  | `searchPlaceholderTextFont?: string;`   |
| **searchPlaceholderTextColor**  | Used to set search placeholder color | `searchPlaceholderTextColor?: string;`  |
| **searchTextFont**              | Used to set search text font         | `searchTextFont?: string;`              |
| **searchTextColor**             | Used to set search text color        | `searchTextColor?: string;`             |
| **emptyStateTextFont**          | Used to set empty state text font    | `emptyStateTextFont?: string;`          |
| **emptyStateTextColor**         | Used to set empty state text color   | `emptyStateTextColor?: string;`         |
| **errorStateTextFont**          | Used to set error state text font    | `errorStateTextFont?: string;`          |
| **errorStateTextColor**         | Used to set error state text color   | `errorStateTextColor?: string;`         |
| **loadingIconTint**             | Used to set loading icon tint        | `loadingIconTint?: string;`             |
| **searchIconTint**              | Used to set search icon tint         | `searchIconTint?: string;`              |
| **searchBorder**                | Used to set search border            | `searchBorder?: string;`                |
| **searchBorderRadius**          | Used to set search border radius     | `searchBorderRadius?: string;`          |
| **searchBackground**            | Used to set search background color  | `searchBackground?: string;`            |
| **onlineStatusColor**           | Used to set online status color      | `onlineStatusColor?: string;`           |
| **separatorColor**              | Used to set separator color          | `separatorColor?: string;`              |
| **boxShadow**                   | Used to set box shadow               | `boxShadow?: string;`                   |
| **backButtonIconTint**          | Used to set back button icon tint    | `backButtonIconTint?: string;`          |
| **closeButtonIconTint**         | Used to set close button icon tint   | `closeButtonIconTint?: string;`         |
| **privateGroupIconBackground**  | Used to set private group icon bg    | `privateGroupIconBackground?: string;`  |
| **passwordGroupIconBackground** | Used to set password group icon bg   | `passwordGroupIconBackground?: string;` |
| **padding**                     | Used to set padding                  | `padding?: string;`                     |

#### 2. GroupScope Style

You can set the `GroupScope` to the Group Members Component to customize the styling.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/-YC7tOebleeoFejE/images/e8a521fe-group_members_group_scope_style_web_screens-34599a8c4e68ecb4d585f4a74f4f54e1.png?fit=max&auto=format&n=-YC7tOebleeoFejE&q=85&s=ed088b6fc4a01cb1a0d419e0f7a5ba2e" width="3600" height="2400" data-path="images/e8a521fe-group_members_group_scope_style_web_screens-34599a8c4e68ecb4d585f4a74f4f54e1.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupMembers,
      ChangeScopeStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const groupScopeStyle = new ChangeScopeStyle({
        activeTextBackground: "#b17efc",
        activeTextColor: "#000000",
        arrowIconTint: "b17efc",
        buttonTextColor: "#ffffff",
      });
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              groupScopeStyle={groupScopeStyle}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupMembers,
      ChangeScopeStyle,
    } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const groupScopeStyle = new ChangeScopeStyle({
        activeTextBackground: "#b17efc",
        activeTextColor: "#000000",
        arrowIconTint: "b17efc",
        buttonTextColor: "#ffffff",
      });
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              groupScopeStyle={groupScopeStyle}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

List of properties exposed by ChangeScopeStyle:

| Property                 | Description                         | Code                             |
| ------------------------ | ----------------------------------- | -------------------------------- |
| **border**               | Used to set border                  | `border?: string,`               |
| **borderRadius**         | Used to set border radius           | `borderRadius?: string;`         |
| **background**           | Used to set background colour       | `background?: string;`           |
| **height**               | Used to set height                  | `height?: string;`               |
| **width**                | Used to set width                   | `width?: string;`                |
| **titleTextFont**        | Used to set title text font         | `titleTextFont?: string,`        |
| **titleTextColor**       | Used to set title text color        | `titleTextColor?: string;`       |
| **activeTextFont**       | Used to set active text font        | `activeTextFont?: string;`       |
| **activeTextColor**      | Used to set active text color       | `activeTextColor?: string;`      |
| **activeTextBackground** | Used to set active text background  | `activeTextBackground?: string;` |
| **arrowIconTint**        | Used to set arrow icon tint         | `arrowIconTint?: string;`        |
| **textFont**             | Used to set text font               | `textFont?: string;`             |
| **textColor**            | Used to set text color              | `textColor?: string;`            |
| **optionBackground**     | Used to set option background color | `optionBackground?: string;`     |
| **optionBorder**         | Used to set option border           | `optionBorder?: string;`         |
| **optionBorderRadius**   | Used to set option border radius    | `optionBorderRadius?: string;`   |
| **hoverTextFont**        | Used to set hover text font         | `hoverTextFont?: string;`        |
| **hoverTextColor**       | Used to set hover text color        | `hoverTextColor?: string;`       |
| **hoverTextBackground**  | Used to set hover text background   | `hoverTextBackground?: string;`  |
| **buttonTextFont**       | Used to set button text font        | `buttonTextFont?: string;`       |
| **buttonTextColor**      | Used to set button text color       | `buttonTextColor?: string;`      |
| **buttonBackground**     | Used to set button background color | `buttonBackground?: string;`     |
| **closeIconTint**        | Used to set close icon tint         | `closeIconTint?: string;`        |

#### 3. Avatar Style

To apply customized styles to the `Avatar` component in the Group Members Component, you can use the following code snippet. For further insights on `Avatar` Styles [refer](/ui-kit/react/v4/avatar#avatar-style)

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupMembers,
      AvatarStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const avatarStyle = new AvatarStyle({
        backgroundColor: "#cdc2ff",
        border: "2px solid #6745ff",
        borderRadius: "10px",
        outerViewBorderColor: "#ca45ff",
        outerViewBorderRadius: "5px",
        nameTextColor: "#4554ff",
      });
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers group={chatGroup} avatarStyle={avatarStyle} />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupMembers,
      AvatarStyle,
    } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const avatarStyle = new AvatarStyle({
        backgroundColor: "#cdc2ff",
        border: "2px solid #6745ff",
        borderRadius: "10px",
        outerViewBorderColor: "#ca45ff",
        outerViewBorderRadius: "5px",
        nameTextColor: "#4554ff",
      });
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers group={chatGroup} avatarStyle={avatarStyle} />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

#### 4. ListItem Style

To apply customized styles to the `ListItemStyle` component in the `Group Members` Component, you can use the following code snippet. For further insights on `ListItemStyle` Styles [refer](/ui-kit/react/v4/list-item)

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupMembers,
      ListItemStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const listItemStyle = new ListItemStyle({
        width: "100%",
        height: "100%",
        border: "2px solid red",
      });
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              listItemStyle={listItemStyle}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupMembers,
      ListItemStyle,
    } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const listItemStyle = new ListItemStyle({
        width: "100%",
        height: "100%",
        border: "2px solid red",
      });
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              listItemStyle={listItemStyle}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

#### 5. StatusIndicator Style

To apply customized styles to the Status Indicator component in the Group Members Component, You can use the following code snippet. For further insights on Status Indicator Styles [refer](/ui-kit/react/v4/status-indicator)

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const statusIndicatorStyle = {
        background: "#db35de",
        height: "10px",
        width: "10px",
      };
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              statusIndicatorStyle={statusIndicatorStyle}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const statusIndicatorStyle = {
        background: "#db35de",
        height: "10px",
        width: "10px",
      };
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              statusIndicatorStyle={statusIndicatorStyle}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

***

### Functionality

These are a set of small functional customizations that allow you to fine-tune the overall experience of the component. With these, you can change text, set custom icons, and toggle the visibility of UI elements.

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              titleAlignment={TitleAlignment.left}
              title="Your Custom Title"
              userPresencePlacement={UserPresencePlacement.right}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              titleAlignment={TitleAlignment.left}
              title="Your Custom Title"
              userPresencePlacement={UserPresencePlacement.right}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/THlknidvlbNx5AzI/images/ab68bcd6-group_members_functionality_default_web_screens-18e39aa26eb93ab520de653bfd2622c3.png?fit=max&auto=format&n=THlknidvlbNx5AzI&q=85&s=f2656b720f5b9991f7cc311b317ed6ab" width="3600" height="2400" data-path="images/ab68bcd6-group_members_functionality_default_web_screens-18e39aa26eb93ab520de653bfd2622c3.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/pIKiBC-6hdnqY01x/images/52b73052-group_members_functionality_custom_web_screens-f3da5329722a33a6a92e4d29d488c18e.png?fit=max&auto=format&n=pIKiBC-6hdnqY01x&q=85&s=501af6d6584d7e776b8a8c32b6d69d1d" width="3600" height="2400" data-path="images/52b73052-group_members_functionality_custom_web_screens-f3da5329722a33a6a92e4d29d488c18e.png" />
</Frame>

Below is a list of customizations along with corresponding code snippets

| Property                             | Description                                                                                                                                                                                                 | Code                                                  |
| ------------------------------------ | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------------------------------- |
| **title** [report]()                 | Used to set title in the app heading                                                                                                                                                                        | `title="Your Custom Title"`                           |
| **errorStateText** [report]()        | Used to set a custom text response when some error occurs on fetching the list of group members                                                                                                             | `errorStateText="your custom error state text"`       |
| **emptyStateText** [report]()        | Used to set a custom text response when fetching the group members has returned an empty list                                                                                                               | `emptyStateText="your custom empty state text"`       |
| **searchIconURL**                    | Used to set search Icon in the search field                                                                                                                                                                 | `searchIconURL="Your Custom search icon"`             |
| **loadingIconURL**                   | Used to set loading Icon                                                                                                                                                                                    | `loadingIconURL="your custom loading icon url"`       |
| **closeButtonIconURL**               | Used to set close button Icon                                                                                                                                                                               | `closeButtonIconURL="your custom close icon url"`     |
| **dropDownIconURL**                  | Used to set the dropdown Icon                                                                                                                                                                               | `dropDownIconURL='Your Custom Dropdown Icon'`         |
| **backButtonIconURL**                | Used to set the back button Icon                                                                                                                                                                            | `backButtonIconURL='Your Custom back Icon'`           |
| **hideError**                        | Used to hide error on fetching groups                                                                                                                                                                       | `hideError={true}`                                    |
| **hideSearch**                       | Used to toggle visibility for search box                                                                                                                                                                    | `hideSearch={true}"`                                  |
| **hideSeparator**                    | Used to hide the divider separating the user items                                                                                                                                                          | `hideSeparator={true}`                                |
| **disableLoadingState** [report]()   | disable the loading state                                                                                                                                                                                   | `disableLoadingState={true}`                          |
| **disableUsersPresence**             | Used to toggle functionality to show user's presence                                                                                                                                                        | `disableUsersPresence={true}`                         |
| **showBackButton**                   | Hides / shows the back button as per the boolean value                                                                                                                                                      | `showBackButton={true}`                               |
| **selectionMode**                    | set the number of group members that can be selected, SelectionMode can be single, multiple or none.                                                                                                        | `selectionMode={SelectionMode.multiple}`              |
| **titleAlignment**                   | Alignment of the heading text for the component                                                                                                                                                             | `titleAlignment={TitleAlignment.center}`              |
| **userPresencePlacement** [report]() | determines the position where the user presence indicator is displayed relative to the user's avatar or name, with `right` or `bottom` indicating it's displayed to the right or bottom of the user's list. | `userPresencePlacement={UserPresencePlacement.right}` |
| **group** [report]()                 | Used to pass group object of which group members will be shown                                                                                                                                              | `group={chatGroup}`                                   |
| **searchKeyword** [report]()         | Used to set the search keyword                                                                                                                                                                              | `searchKeyword='alice'`                               |
| **searchPlaceholder** [report]()     | Used to set custom search placeholder text                                                                                                                                                                  | `searchPlaceholder='Custom Search PlaceHolder'`       |

***

### Advance

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your views, layouts, and UI elements and then incorporate those into the component.

***

#### ListItemView

With this property, you can assign a custom ListItem to the Group Members Component.

```
listItemView = { getListItemView };
```

**Example**

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/HFXOvmhiLRb5ClID/images/9137f1fe-group_members_listitemview_default_web_screens-a43d8f857bde1756bcec0f452244ee13.png?fit=max&auto=format&n=HFXOvmhiLRb5ClID&q=85&s=2cbf2f339d64a68ba8f8e0bac3b395fd" width="3600" height="2400" data-path="images/9137f1fe-group_members_listitemview_default_web_screens-a43d8f857bde1756bcec0f452244ee13.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/udim9ku6wPsRNXGs/images/e0dd446d-group_members_listitemview_custom_web_screens-bdad2d69ca8e8931ee338c88f1ef84d3.png?fit=max&auto=format&n=udim9ku6wPsRNXGs&q=85&s=bd6a9fbca35b2d0d78e9e3ffde700db4" width="3600" height="2400" data-path="images/e0dd446d-group_members_listitemview_custom_web_screens-bdad2d69ca8e8931ee338c88f1ef84d3.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      const getListItemView = (groupMembers: CometChat.GroupMember) => {
        return (
          <div
            style={{
              display: "flex",
              alignItems: "left",
              padding: "10px",
              border: "2px solid #e9baff",
              borderRadius: "20px",
              background: "#6e2bd9",
            }}
          >
            <cometchat-avatar
              image={groupMembers.getAvatar()}
              name={groupMembers.getName()}
            />

            <div style={{ display: "flex", paddingLeft: "10px" }}>
              <div
                style={{ fontWeight: "bold", color: "#ffffff", fontSize: "14px" }}
              >
                {groupMembers.getName()}
                <div
                  style={{ color: "#ffffff", fontSize: "10px", textAlign: "left" }}
                >
                  {groupMembers.getStatus()}{" "}
                </div>
              </div>
            </div>
          </div>
        );
      };

      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              listItemView={getListItemView}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      const getListItemView = (groupMembers) => {
        return (
          <div
            style={{
              display: "flex",
              alignItems: "left",
              padding: "10px",
              border: "2px solid #e9baff",
              borderRadius: "20px",
              background: "#6e2bd9",
            }}
          >
            <cometchat-avatar
              image={groupMembers.getAvatar()}
              name={groupMembers.getName()}
            />

            <div style={{ display: "flex", paddingLeft: "10px" }}>
              <div
                style={{ fontWeight: "bold", color: "#ffffff", fontSize: "14px" }}
              >
                {groupMembers.getName()}
                <div
                  style={{ color: "#ffffff", fontSize: "10px", textAlign: "left" }}
                >
                  {groupMembers.getStatus()}{" "}
                </div>
              </div>
            </div>
          </div>
        );
      };
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              listItemView={getListItemView}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

***

#### SubtitleView

You can customize the subtitle view for each group members to meet your requirements

```
subtitleView = { getSubtitleView };
```

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/7-hZ4AEh99NJJtEC/images/97dfe425-group_members_subtitleview_default_web_screens-ed7e2c8f329a2681e1dd06e1d9700139.png?fit=max&auto=format&n=7-hZ4AEh99NJJtEC&q=85&s=05fc13d665165c06978605139bdb0a63" width="3600" height="2400" data-path="images/97dfe425-group_members_subtitleview_default_web_screens-ed7e2c8f329a2681e1dd06e1d9700139.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/F0pRX00dbgkztAbW/images/114d3fff-group_members_subtitleview_custom_web_screens-0a698b72b22c8ac223f02db596cf13d6.png?fit=max&auto=format&n=F0pRX00dbgkztAbW&q=85&s=1a612a2606906cf5caeb897665e65524" width="3600" height="2400" data-path="images/114d3fff-group_members_subtitleview_custom_web_screens-0a698b72b22c8ac223f02db596cf13d6.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      const getSubtitleView = (
        groupMembers: CometChat.GroupMember
      ): JSX.Element => {
        function formatTime(timestamp: number) {
          const date = new Date(timestamp * 1000);
          return date.toLocaleString();
        }
        if (groupMembers instanceof CometChat.GroupMember) {
          return (
            <div
              style={{
                display: "flex",
                alignItems: "left",
                padding: "2px",
                fontSize: "10px",
              }}
            >
              <div style={{ color: "gray" }}>
                Last Active At: {formatTime(groupMembers.getLastActiveAt())}
              </div>
            </div>
          );
        } else {
          return <></>;
        }
      };

      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              subtitleView={getSubtitleView}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      const getSubtitleView = (groupMembers) => {
        function formatTime(timestamp) {
          const date = new Date(timestamp * 1000);
          return date.toLocaleString();
        }
        if (groupMembers instanceof CometChat.GroupMember) {
          return (
            <div
              style={{
                display: "flex",
                alignItems: "left",
                padding: "2px",
                fontSize: "10px",
              }}
            >
              <div style={{ color: "gray" }}>
                Last Active At: {formatTime(groupMembers.getLastActiveAt())}
              </div>
            </div>
          );
        } else {
          return <></>;
        }
      };
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              subtitleView={getSubtitleView}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

***

#### TailView

You can customize the tail view for each group members to meet your requirements

```
tailView = { getTailView };
```

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/4xujL4pc0yDqaECl/images/d3af363a-group_members_tailview_default_web_screens-16df8485b0b6c03b4ddf58eef9487d64.png?fit=max&auto=format&n=4xujL4pc0yDqaECl&q=85&s=f55998534e2fbfe90402362abacbe0cd" width="3600" height="2400" data-path="images/d3af363a-group_members_tailview_default_web_screens-16df8485b0b6c03b4ddf58eef9487d64.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/2U5tVIzH12dbbFtr/images/ad4e8cf3-group_members_tailview_custom_web_screens-dd072f924cce0e2cfd870de378963df5.png?fit=max&auto=format&n=2U5tVIzH12dbbFtr&q=85&s=523a9d534bf61a4d7ceb3e1110b96efc" width="3600" height="2400" data-path="images/ad4e8cf3-group_members_tailview_custom_web_screens-dd072f924cce0e2cfd870de378963df5.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      function getTailView(groupMember: CometChat.GroupMember): JSX.Element {
        return (
          <div
            style={{
              color: "#5a00a8",
              border: "1px solid #5a00a8",
              borderRadius: "12px",
              padding: "5px",
            }}
          >
            {groupMember.getScope()}
          </div>
        );
      }

      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers group={chatGroup} tailView={getTailView} />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      function getTailView(groupMember) {
        return (
          <div
            style={{
              color: "#5a00a8",
              border: "1px solid #5a00a8",
              borderRadius: "12px",
              padding: "5px",
            }}
          >
            {groupMember.getScope()}
          </div>
        );
      }
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers group={chatGroup} tailView={getTailView} />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

***

#### EmptyStateView

You can set a custom `EmptyStateView` using `emptyStateView` to match the empty view of your app.

```javascript theme={null}
emptyStateView={getEmptyStateView()}
```

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/SNc1XUNfZQ5aQj_q/images/ff387d20-group_members_empty_stateview_default_web_screens-89587f3bfc14a6d794cc18e45257e9b4.png?fit=max&auto=format&n=SNc1XUNfZQ5aQj_q&q=85&s=a76d0369c06744261ffa8be4b34a87c9" width="3600" height="2400" data-path="images/ff387d20-group_members_empty_stateview_default_web_screens-89587f3bfc14a6d794cc18e45257e9b4.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/KVBs_L3B6NmQumhv/images/0a04ec4f-group_members_empty_stateview_custom_web_screens-3c40c4e92a0db1e7140ec7254334a546.png?fit=max&auto=format&n=KVBs_L3B6NmQumhv&q=85&s=6b9b94122a2b7733ae0f3b468c134086" width="3600" height="2400" data-path="images/0a04ec4f-group_members_empty_stateview_custom_web_screens-3c40c4e92a0db1e7140ec7254334a546.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      const getEmptyStateView = () => {
        return (
          <div style={{ color: "#d6cfff", fontSize: "30px", font: "bold" }}>
            Your Custom Empty State
          </div>
        );
      };

      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              emptyStateView={getEmptyStateView()}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      const getEmptyStateView = () => {
        return (
          <div style={{ color: "#d6cfff", fontSize: "30px", font: "bold" }}>
            Your Custom Empty State
          </div>
        );
      };
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              emptyStateView={getEmptyStateView()}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

***

#### ErrorStateView

You can set a custom `ErrorStateView` using `errorStateView` to match the error view of your app.

```javascript theme={null}
errorSateView={getErrorStateView()}
```

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/bKHmaxDqzaJZWwLS/images/47d3da72-group_members_error_stateview_default_web_screens-0fc50b78d3a4f6c5652a9b1e905818f1.png?fit=max&auto=format&n=bKHmaxDqzaJZWwLS&q=85&s=a328c7d848eae6e2ff258e24ba983919" width="3600" height="2400" data-path="images/47d3da72-group_members_error_stateview_default_web_screens-0fc50b78d3a4f6c5652a9b1e905818f1.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/dDWpooIQ48haNjyU/images/79de2c4b-group_members_error_stateview_custom_web_screens-92c528d899e2c86d782e2a5d5848213f.png?fit=max&auto=format&n=dDWpooIQ48haNjyU&q=85&s=26a6aab1176f1433d490a038b8c3ac90" width="3600" height="2400" data-path="images/79de2c4b-group_members_error_stateview_custom_web_screens-92c528d899e2c86d782e2a5d5848213f.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      const getErrorStateView = () => {
        return (
          <div style={{ height: "100vh", width: "100vw" }}>
            <img
              src="image"
              alt="error icon"
              style={{
                height: "100px",
                width: "100px",
                marginTop: "250px",
                justifyContent: "center",
              }}
            ></img>
          </div>
        );
      };

      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              errorSateView={getErrorStateView()}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      const getErrorStateView = () => {
        return (
          <div style={{ height: "100vh", width: "100vw" }}>
            <img
              src="image"
              alt="error icon"
              style={{
                height: "100px",
                width: "100px",
                marginTop: "250px",
                justifyContent: "center",
              }}
            ></img>
          </div>
        );
      };
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              errorSateView={getErrorStateView()}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

***

#### Menus

You can set the Custom Menu view to add more options to the Group Members component.

```javascript theme={null}
menus={getMenus()}
```

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/tI1D0nyKUVcz2LEZ/images/c33a0afe-group_members_menus_web_screens-460e3723881237df66214c3e5aaae06c.png?fit=max&auto=format&n=tI1D0nyKUVcz2LEZ&q=85&s=de2402f840d0e2cb39fe2b84609fb34b" width="3600" height="2400" data-path="images/c33a0afe-group_members_menus_web_screens-460e3723881237df66214c3e5aaae06c.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      const getMenus = () => {
        const handleReload = () => {
          window.location.reload();
        };
        const getButtonStyle = () => {
          return {
            height: "20px",
            width: "20px",
            border: "none",
            borderRadius: "0",
            background: "transparent",
            buttonIconTint: "#7E57C2",
          };
        };
        return (
          <div style={{ marginRight: "20px" }}>
            <cometchat-button
              iconURL="Icon"
              buttonStyle={JSON.stringify(getButtonStyle())}
              onClick={handleReload}
            >
              {" "}
            </cometchat-button>
          </div>
        );
      };

      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers group={chatGroup} menus={getMenus()} />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      const getMenus = () => {
        const handleReload = () => {
          window.location.reload();
        };
        const getButtonStyle = () => {
          return {
            height: "20px",
            width: "20px",
            border: "none",
            borderRadius: "0",
            background: "transparent",
            buttonIconTint: "#7E57C2",
          };
        };
        return (
          <div style={{ marginRight: "20px" }}>
            <cometchat-button
              iconURL="Icon"
              buttonStyle={JSON.stringify(getButtonStyle())}
              onClick={handleReload}
            >
              {" "}
            </cometchat-button>
          </div>
        );
      };
      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers group={chatGroup} menus={getMenus()} />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

***

#### Options

You can set the Custom options to the Group Members component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/tiy_c-4NywbKIGIr/images/7cfb3141-group_members_options_web_screens-511f7e92c96d1f252461f3b5d6f63828.png?fit=max&auto=format&n=tiy_c-4NywbKIGIr&q=85&s=30eef5496cff66bb5253c0086bcc7e3b" width="3600" height="2400" data-path="images/7cfb3141-group_members_options_web_screens-511f7e92c96d1f252461f3b5d6f63828.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    GroupMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupMembers,
      CometChatOption,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<CometChat.Group>();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              options={(
                group: CometChat.Group,
                groupMember: CometChat.GroupMember
              ) => {
                const customOptions = [
                  new CometChatOption({
                    id: "1",
                    title: "Title",
                    iconURL: "Icon",
                    backgroundColor: "transparent",
                    onClick: () => {
                      console.log(
                        "Custom option clicked for group members:",
                        groupMember
                      );
                    },
                    iconTint: "#6851D6",
                    titleColor: "#000000",
                  }),
                ];
                return customOptions;
              }}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    GroupMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatGroupMembers,
      CometChatOption,
    } from "@cometchat/chat-uikit-react";
    import React, { useEffect, useState } from "react";

    const GroupMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);

      return (
        <>
          {chatGroup && (
            <CometChatGroupMembers
              group={chatGroup}
              options={(group, groupMember) => {
                const customOptions = [
                  new CometChatOption({
                    id: "1",
                    title: "Title",
                    iconURL: "icon",
                    backgroundColor: "transparent",
                    onClick: () => {
                      console.log(
                        "Custom option clicked for group members:",
                        groupMember
                      );
                    },
                    iconTint: "#6851D6",
                    titleColor: "#000000",
                  }),
                ];
                return customOptions;
              }}
            />
          )}
        </>
      );
    };

    export default GroupMembersDemo;
    ```
  </Tab>
</Tabs>

***


> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Group Members

> Group Members — CometChat documentation.

## Overview

`CometChatGroupMembers` is a [Component](/docs/ui-kit/angular/v4/components-overview#components) that displays all users added or invited to a group, granting them access to group discussions, shared content, and collaborative features. Group members can communicate in real-time via messaging, voice and video calls, and other activities. They can interact, share files, and join calls based on group permissions set by the administrator or owner.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/v4EbHQCGZ54oJcmr/images/5b095cf9-group_members_overview_web_screens-ed7e2c8f329a2681e1dd06e1d9700139.png?fit=max&auto=format&n=v4EbHQCGZ54oJcmr&q=85&s=63c1099094029c236ac8bed6ab46eb15" width="3600" height="2400" data-path="images/5b095cf9-group_members_overview_web_screens-ed7e2c8f329a2681e1dd06e1d9700139.png" />
</Frame>

***

## Usage

### Integration

The following code snippet illustrates how you can directly incorporate the Group Members component into your Application.

<Tabs>
  <Tab title="app.module.ts">
    ```ts theme={null}
    import { CUSTOM_ELEMENTS_SCHEMA, NgModule } from "@angular/core";
    import { BrowserModule } from "@angular/platform-browser";
    import { CometChatGroupMembers } from "@cometchat/chat-uikit-angular";
    import { AppComponent } from "./app.component";

    @NgModule({
      imports: [BrowserModule, CometChatGroupMembers],
      declarations: [AppComponent],
      providers: [],
      bootstrap: [AppComponent],
      schemas: [CUSTOM_ELEMENTS_SCHEMA],
    })
    export class AppModule {}
    ```
  </Tab>

  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-group-members
        *ngIf="groupObject"
        [group]="groupObject"
      ></cometchat-group-members>
    </div>
    ```
  </Tab>
</Tabs>

***

### Actions

[Actions](/docs/ui-kit/angular/v4/components-overview#actions) dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.

##### 1. onSelect

The `onSelect` action is activated when you select the done icon while in selection mode. This returns a list of all the group members that you have selected.

This action does not come with any predefined behavior. However, you have the flexibility to override this event and tailor it to suit your needs using the following code snippet.

***

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { SelectionMode } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      public selectionMode: SelectionMode = SelectionMode.multiple;
      public handleOnSelectGroupMembers = (groupMember: CometChat.GroupMember, selected: boolean) => {
        console.log("your custom on select actions",groupMember, selected);
      };
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [selectionMode]="selectionMode"
        [onSelect]="handleOnSelectGroupMembers"
      ></cometchat-create-group>
    </div>
    ```
  </Tab>
</Tabs>

##### 2. onItemClick

The `onItemClick` event is activated when you click on the Group Members List item. This action does not come with any predefined behavior. However, you have the flexibility to override this event and tailor it to suit your needs using the following code snippet.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      public handleOnItemClickGroupMembers = (user: CometChat.GroupMember) => {
        console.log("your custom on item click action", user);
      };
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [onItemClick]="handleOnItemClickGroupMembers"
      ></cometchat-create-group>
    </div>
    ```
  </Tab>
</Tabs>

##### 3. onBack

`OnBack` is triggered when you click on the back button of the Group Members component. You can override this action using the following code snippet.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      public handleOnBack = () => {
        console.log("Your custom on back action");
      }
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [onBack]="handleOnBack"
      ></cometchat-create-group>
    </div>
    ```
  </Tab>
</Tabs>

##### 4. onClose

`onClose` is triggered when you click on the close button of the Group Members component. You can override this action using the following code snippet.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      public handleOnClose = () => {
        console.log("Your custom on close actions");
      };
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [onClose]="handleOnClose"
      ></cometchat-create-group>
    </div>
    ```
  </Tab>
</Tabs>

##### 5. onEmpty

This action allows you to specify a callback function to be executed when a certain condition, typically the absence of data or content, is met within the component or element.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      public handleOnEmpty = () =>{
        console.log("your custom on empty action");
      }
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [onEmpty]="handleOnEmpty"
      ></cometchat-create-group>
    </div>
    ```
  </Tab>
</Tabs>

##### 6. onError

This action doesn't change the behavior of the component but rather listens for any errors that occur in the Group Members component.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      public handleOnError = (error: CometChat.CometChatException) => {
        console.log("your custom on error action", error);
      };
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [onError]="handleOnError"
      ></cometchat-create-group>
    </div>
    ```
  </Tab>
</Tabs>

***

### Filters

**Filters** allow you to customize the data displayed in a list within a Component. You can filter the list based on your specific criteria, allowing for a more customized. Filters can be applied using RequestBuilders of Chat SDK.

##### 1. GroupMembersRequestBuilder

The [GroupMembersRequestBuilder](/docs/sdk/javascript/retrieve-group-members) enables you to filter and customize the group members list based on available parameters in GroupMembersRequestBuilder. This feature allows you to create more specific and targeted queries when fetching groups. The following are the parameters available in [GroupMembersRequestBuilder](/docs/sdk/javascript/retrieve-group-members)

| Methods              | Type           | Description                                                                                       |
| -------------------- | -------------- | ------------------------------------------------------------------------------------------------- |
| **setLimit**         | number         | sets the number of group members that can be fetched in a single request, suitable for pagination |
| **setSearchKeyword** | String         | used for fetching group members matching the passed string                                        |
| **setScopes**        | Array\<String> | used for fetching group members based on multiple scopes                                          |

**Example**

In the example below, we are applying a filter to the Group Members by setting the limit to two and setting the scope to show only admin and moderator.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      groupMemberRequestBuilder = new CometChat.GroupMembersRequestBuilder('guid').setLimit(2).setScopes(['admin', 'moderator'])

      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [groupMemberRequestBuilder]="groupMemberRequestBuilder"
      ></cometchat-create-group>
    </div>
    ```
  </Tab>
</Tabs>

***

##### 2. SearchRequestBuilder

The SearchRequestBuilder uses [GroupMembersRequestBuilder](/docs/sdk/javascript/retrieve-group-members) enables you to filter and customize the search list based on available parameters in GroupMembersRequestBuilder. This feature allows you to keep uniformity between the displayed Group Members List and searched Group Members List.

**Example**

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      searchRequestBuilder = new CometChat.GroupMembersRequestBuilder('guid').setLimit(2).setSearchKeyword('**')
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [searchRequestBuilder]="searchRequestBuilder"
      ></cometchat-create-group>
    </div>
    ```
  </Tab>
</Tabs>

***

### Events

[Events](/docs/ui-kit/angular/v4/components-overview#events) are emitted by a `Component`. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed.

Events emitted by the Group Members component is as follows.

| Event                         | Description                                                       |
| ----------------------------- | ----------------------------------------------------------------- |
| **ccGroupMemberBanned**       | Triggers when the group member banned from the group successfully |
| **ccGroupMemberKicked**       | Triggers when the group member kicked from the group successfully |
| **ccGroupMemberScopeChanged** | Triggers when the group member scope is changed in the group      |

<Tabs>
  <Tab title="TypeScript">
    ```ts theme={null}
    import {CometChatGroupEvents} from "@cometchat/chat-uikit-angular";

    this.ccGroupMemberBanned = CometChatGroupEvents.ccGroupMemberBanned.subscribe(
      (item: IGroupMemberKickedBanned) => {
            // Your Code
      }
    );

    this.ccGroupMemberKicked = CometChatGroupEvents.ccGroupMemberKicked.subscribe(
      (item: IGroupMemberKickedBanned) => {
            // Your Code
      }
    );

    this.ccGroupMemberScopeChanged = CometChatGroupEvents.ccGroupMemberScopeChanged.subscribe(
      (item: IGroupMemberScopeChanged) => {
            // Your Code
      }
    );
    ```
  </Tab>
</Tabs>

***

Removing `CometChatGroupEvents` Listener's

<Tabs>
  <Tab title="TypeScript">
    ```ts theme={null}
    this.ccGroupMemberBanned.unsubscribe();
    this.ccGroupMemberKicked.unsubscribe();
    this.ccGroupMemberScopeChanged.unsubscribe();
    ```
  </Tab>
</Tabs>

***

## Customization

To fit your app's design requirements, you can customize the appearance of the Group Members component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

### Style

Using **Style** you can **customize** the look and feel of the component in your app, These parameters typically control elements such as the **color**, **size**, **shape**, and **fonts** used within the component.

##### 1. GroupMembers Style

You can set the `GroupMembersStyle` to the Group Members Component to customize the styling.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Q-VZaihy61fy3D_G/images/2097412c-group_members_style_web_screens-bea9be2e9c7162f28391b74c514a8b08.png?fit=max&auto=format&n=Q-VZaihy61fy3D_G&q=85&s=1584af9cc1a7949a7d9bd7f3d5bb8aeb" width="3600" height="2400" data-path="images/2097412c-group_members_style_web_screens-bea9be2e9c7162f28391b74c514a8b08.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { GroupMembersStyle } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      groupMembersStyle = new GroupMembersStyle({
        background: "#b17efc",
        searchPlaceholderTextColor: "#ffffff",
        titleTextColor: "#000000",
        searchBackground: "#5718b5",
      });
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [groupMembersStyle]="groupMembersStyle"
      ></cometchat-create-group>
    </div>
    ```
  </Tab>
</Tabs>

List of properties exposed by GroupMembersStyle:

| Property                        | Description                          | Code                                    |
| ------------------------------- | ------------------------------------ | --------------------------------------- |
| **border**                      | Used to set border                   | `border?: string,`                      |
| **borderRadius**                | Used to set border radius            | `borderRadius?: string;`                |
| **background**                  | Used to set background colour        | `background?: string;`                  |
| **height**                      | Used to set height                   | `height?: string;`                      |
| **width**                       | Used to set width                    | `width?: string;`                       |
| **titleTextFont**               | Used to set title text font          | `titleTextFont?: string,`               |
| **titleTextColor**              | Used to set title text color         | `titleTextColor?: string;`              |
| **searchPlaceholderTextFont**   | Used to set search placeholder font  | `searchPlaceholderTextFont?: string;`   |
| **searchPlaceholderTextColor**  | Used to set search placeholder color | `searchPlaceholderTextColor?: string;`  |
| **searchTextFont**              | Used to set search text font         | `searchTextFont?: string;`              |
| **searchTextColor**             | Used to set search text color        | `searchTextColor?: string;`             |
| **emptyStateTextFont**          | Used to set empty state text font    | `emptyStateTextFont?: string;`          |
| **emptyStateTextColor**         | Used to set empty state text color   | `emptyStateTextColor?: string;`         |
| **errorStateTextFont**          | Used to set error state text font    | `errorStateTextFont?: string;`          |
| **errorStateTextColor**         | Used to set error state text color   | `errorStateTextColor?: string;`         |
| **loadingIconTint**             | Used to set loading icon tint        | `loadingIconTint?: string;`             |
| **searchIconTint**              | Used to set search icon tint         | `searchIconTint?: string;`              |
| **searchBorder**                | Used to set search border            | `searchBorder?: string;`                |
| **searchBorderRadius**          | Used to set search border radius     | `searchBorderRadius?: string;`          |
| **searchBackground**            | Used to set search background color  | `searchBackground?: string;`            |
| **onlineStatusColor**           | Used to set online status color      | `onlineStatusColor?: string;`           |
| **separatorColor**              | Used to set separator color          | `separatorColor?: string;`              |
| **boxShadow**                   | Used to set box shadow               | `boxShadow?: string;`                   |
| **backButtonIconTint**          | Used to set back button icon tint    | `backButtonIconTint?: string;`          |
| **closeButtonIconTint**         | Used to set close button icon tint   | `closeButtonIconTint?: string;`         |
| **privateGroupIconBackground**  | Used to set private group icon bg    | `privateGroupIconBackground?: string;`  |
| **passwordGroupIconBackground** | Used to set password group icon bg   | `passwordGroupIconBackground?: string;` |
| **padding**                     | Used to set padding                  | `padding?: string;`                     |

##### 2. GroupScope Style

You can set the `GroupScope` to the Group Members Component to customize the styling.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/-YC7tOebleeoFejE/images/e8a521fe-group_members_group_scope_style_web_screens-34599a8c4e68ecb4d585f4a74f4f54e1.png?fit=max&auto=format&n=-YC7tOebleeoFejE&q=85&s=ed088b6fc4a01cb1a0d419e0f7a5ba2e" width="3600" height="2400" data-path="images/e8a521fe-group_members_group_scope_style_web_screens-34599a8c4e68ecb4d585f4a74f4f54e1.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ChangeScopeStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      groupScopeStyle = new ChangeScopeStyle({
        activeTextBackground: "#b17efc",
        activeTextColor: "#000000",
        arrowIconTint: "b17efc",
        buttonTextColor: "#ffffff",
        height:'400px',
        width:'400px'
      });
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [groupScopeStyle]="groupScopeStyle"
      ></cometchat-create-group>
    </div>
    ```
  </Tab>
</Tabs>

List of properties exposed by ChangeScopeStyle:

| Property                 | Description                         | Code                             |
| ------------------------ | ----------------------------------- | -------------------------------- |
| **border**               | Used to set border                  | `border?: string,`               |
| **borderRadius**         | Used to set border radius           | `borderRadius?: string;`         |
| **background**           | Used to set background colour       | `background?: string;`           |
| **height**               | Used to set height                  | `height?: string;`               |
| **width**                | Used to set width                   | `width?: string;`                |
| **titleTextFont**        | Used to set title text font         | `titleTextFont?: string,`        |
| **titleTextColor**       | Used to set title text color        | `titleTextColor?: string;`       |
| **activeTextFont**       | Used to set active text font        | `activeTextFont?: string;`       |
| **activeTextColor**      | Used to set active text color       | `activeTextColor?: string;`      |
| **activeTextBackground** | Used to set active text background  | `activeTextBackground?: string;` |
| **arrowIconTint**        | Used to set arrow icon tint         | `arrowIconTint?: string;`        |
| **textFont**             | Used to set text font               | `textFont?: string;`             |
| **textColor**            | Used to set text color              | `textColor?: string;`            |
| **optionBackground**     | Used to set option background color | `optionBackground?: string;`     |
| **optionBorder**         | Used to set option border           | `optionBorder?: string;`         |
| **optionBorderRadius**   | Used to set option border radius    | `optionBorderRadius?: string;`   |
| **hoverTextFont**        | Used to set hover text font         | `hoverTextFont?: string;`        |
| **hoverTextColor**       | Used to set hover text color        | `hoverTextColor?: string;`       |
| **hoverTextBackground**  | Used to set hover text background   | `hoverTextBackground?: string;`  |
| **buttonTextFont**       | Used to set button text font        | `buttonTextFont?: string;`       |
| **buttonTextColor**      | Used to set button text color       | `buttonTextColor?: string;`      |
| **buttonBackground**     | Used to set button background color | `buttonBackground?: string;`     |
| **closeIconTint**        | Used to set close icon tint         | `closeIconTint?: string;`        |

##### 3. Avatar Style

To apply customized styles to the `Avatar` component in the Group Members Component, you can use the following code snippet. For further insights on `Avatar` Styles [refer](/docs/ui-kit/angular/v4/avatar#avatar-style)

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, AvatarStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      avatarStyle = new AvatarStyle({
        backgroundColor: "#cdc2ff",
        border: "2px solid #6745ff",
        borderRadius: "10px",
        outerViewBorderColor: "#ca45ff",
        outerViewBorderRadius: "5px",
        nameTextColor: "#4554ff"
      });
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [avatarStyle]="avatarStyle"
      ></cometchat-create-group>
    </div>
    ```
  </Tab>
</Tabs>

##### 4. ListItem Style

To apply customized styles to the `List Item` component in the `Group Members` Component, you can use the following code snippet. For further insights on `List Item` Styles [refer](/docs/ui-kit/angular/v4/list-item)

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ListItemStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      listItemStyle: ListItemStyle = new ListItemStyle({
        background: "transparent",
        padding: "5px",
        border: "1px solid #e9b8f5",
        titleColor: "#8830f2",
        borderRadius: "20px",
        width: "100% !important"
      });
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [listItemStyle]="listItemStyle"
      ></cometchat-create-group>
    </div>
    ```
  </Tab>
</Tabs>

##### 5. StatusIndicator Style

To apply customized styles to the Status Indicator component in the Group Members Component, You can use the following code snippet. For further insights on Status Indicator Styles [refer](/docs/ui-kit/angular/v4/status-indicator)

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      statusIndicatorStyle: any = ({
        height: '20px',
        width: '20px',
        backgroundColor: 'red'
      });
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [statusIndicatorStyle]="statusIndicatorStyle"
      ></cometchat-create-group>
    </div>
    ```
  </Tab>
</Tabs>

***

### Functionality

These are a set of small functional customizations that allow you to fine-tune the overall experience of the component. With these, you can change text, set custom icons, and toggle the visibility of UI elements.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { TitleAlignment,UserPresencePlacement } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      titleAlignment = TitleAlignment.center;
      userPresencePlacement = UserPresencePlacement.right;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [titleAlignment]="titleAlignment"
        [title]="'Your Custom Title'"
        [userPresencePlacement]="userPresencePlacement"
      ></cometchat-create-group>
    </div>
    ```
  </Tab>
</Tabs>

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/THlknidvlbNx5AzI/images/ab68bcd6-group_members_functionality_default_web_screens-18e39aa26eb93ab520de653bfd2622c3.png?fit=max&auto=format&n=THlknidvlbNx5AzI&q=85&s=f2656b720f5b9991f7cc311b317ed6ab" width="3600" height="2400" data-path="images/ab68bcd6-group_members_functionality_default_web_screens-18e39aa26eb93ab520de653bfd2622c3.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/pIKiBC-6hdnqY01x/images/52b73052-group_members_functionality_custom_web_screens-f3da5329722a33a6a92e4d29d488c18e.png?fit=max&auto=format&n=pIKiBC-6hdnqY01x&q=85&s=501af6d6584d7e776b8a8c32b6d69d1d" width="3600" height="2400" data-path="images/52b73052-group_members_functionality_custom_web_screens-f3da5329722a33a6a92e4d29d488c18e.png" />
</Frame>

Below is a list of customizations along with corresponding code snippets

| Property                                                            | Description                                                                                                                                                                                                 | Code                                                |
| ------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | --------------------------------------------------- |
| **title** <Tooltip tip="Not available">🛑</Tooltip>                 | Used to set title in the app heading                                                                                                                                                                        | `[title]="'Your Custom Title'"`                     |
| **errorStateText** <Tooltip tip="Not available">🛑</Tooltip>        | Used to set a custom text response when some error occurs on fetching the list of group members                                                                                                             | `[errorStateText]="'your custom error state text'"` |
| **emptyStateText** <Tooltip tip="Not available">🛑</Tooltip>        | Used to set a custom text response when fetching the group members has returned an empty list                                                                                                               | `[emptyStateText]="'your custom empty state text'"` |
| **searchIconURL**                                                   | Used to set search Icon in the search field                                                                                                                                                                 | `[searchIconURL]="searchIconURL"`                   |
| **loadingIconURL**                                                  | Used to set loading Icon                                                                                                                                                                                    | `[loadingIconURL]="loadingIconURL"`                 |
| **closeButtonIconURL**                                              | Used to set close button Icon                                                                                                                                                                               | `[closeButtonIconURL]="closeButtonIconURL"`         |
| **dropDownIconURL**                                                 | Used to set the dropdown Icon                                                                                                                                                                               | `[dropDownIconURL]="dropDownIconURL"`               |
| **backButtonIconURL**                                               | Used to set the back button Icon                                                                                                                                                                            | `[backButtonIconURL]="backButtonIconURL"`           |
| **hideError**                                                       | Used to hide error on fetching groups                                                                                                                                                                       | `[hideError]="true"`                                |
| **hideSearch**                                                      | Used to toggle visibility for search box                                                                                                                                                                    | `[hideSearch]="true"`                               |
| **hideSeparator**                                                   | Used to hide the divider separating the user items                                                                                                                                                          | `[hideSeparator]="true"`                            |
| **disableLoadingState** <Tooltip tip="Not available">🛑</Tooltip>   | disable the loading state                                                                                                                                                                                   | `[disableLoadingState]="true"`                      |
| **disableUsersPresence**                                            | Used to toggle functionality to show user's presence                                                                                                                                                        | `[disableUsersPresence]="true`                      |
| **showBackButton**                                                  | Hides / shows the back button as per the boolean value                                                                                                                                                      | `[showBackButton]="true"`                           |
| **selectionMode**                                                   | set the number of group members that can be selected, SelectionMode can be single, multiple or none.                                                                                                        | `[selectionMode]="selectionMode"`                   |
| **titleAlignment**                                                  | Alignment of the heading text for the component                                                                                                                                                             | `[titleAlignment]="titleAlignment"`                 |
| **userPresencePlacement** <Tooltip tip="Not available">🛑</Tooltip> | determines the position where the user presence indicator is displayed relative to the user's avatar or name, with `right` or `bottom` indicating it's displayed to the right or bottom of the user's list. | `[userPresencePlacement]="userPresencePlacement"`   |
| **group** <Tooltip tip="Not available">🛑</Tooltip>                 | Used to pass group object of which group members will be shown                                                                                                                                              | `[group]="groupObject"`                             |
| **searchKeyword** <Tooltip tip="Not available">🛑</Tooltip>         | Used to set the search keyword                                                                                                                                                                              | `[searchKeyword]="'alice'"`                         |
| **searchPlaceholder** <Tooltip tip="Not available">🛑</Tooltip>     | Used to set custom search placeholder text                                                                                                                                                                  | `[searchPlaceholder]="'Custom Search PlaceHolder'"` |

***

### Advance

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your views, layouts, and UI elements and then incorporate those into the component.

***

#### ListItemView

With this property, you can assign a custom ListItem to the Group Members Component.

**Example**

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/HFXOvmhiLRb5ClID/images/9137f1fe-group_members_listitemview_default_web_screens-a43d8f857bde1756bcec0f452244ee13.png?fit=max&auto=format&n=HFXOvmhiLRb5ClID&q=85&s=2cbf2f339d64a68ba8f8e0bac3b395fd" width="3600" height="2400" data-path="images/9137f1fe-group_members_listitemview_default_web_screens-a43d8f857bde1756bcec0f452244ee13.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/udim9ku6wPsRNXGs/images/e0dd446d-group_members_listitemview_custom_web_screens-bdad2d69ca8e8931ee338c88f1ef84d3.png?fit=max&auto=format&n=udim9ku6wPsRNXGs&q=85&s=bd6a9fbca35b2d0d78e9e3ffde700db4" width="3600" height="2400" data-path="images/e0dd446d-group_members_listitemview_custom_web_screens-bdad2d69ca8e8931ee338c88f1ef84d3.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;

      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [listItemView]="listItemViewTemplate"
      ></cometchat-create-group>
    </div>

    <ng-template #listItemViewTemplate let-groupMember>
      <div
        [ngStyle]="{
          display: 'flex',
          alignItems: 'left',
          padding: '10px',
          border: '2px solid #e9baff',
          borderRadius: '20px',
          background: '#ffffff'
        }"
      >
        <cometchat-avatar
          [image]="groupMember.getAvatar()"
          [name]="groupMember.getName()"
        ></cometchat-avatar>
        <div [ngStyle]="{ display: 'flex', paddingLeft: '10px' }">
          <div
            [ngStyle]="{
              fontWeight: 'bold',
              color: '#937aff',
              fontSize: '14px',
              marginTop: '5px'
            }"
          >
            {{ groupMember.getName() }}
            <div
              [ngStyle]="{
                color: '#cfc4ff',
                fontSize: '10px',
                textAlign: 'left'
              }"
            >
              {{ groupMember.getStatus() }}
            </div>
          </div>
        </div>
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### SubtitleView

You can customize the subtitle view for each group members to meet your requirements

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/7-hZ4AEh99NJJtEC/images/97dfe425-group_members_subtitleview_default_web_screens-ed7e2c8f329a2681e1dd06e1d9700139.png?fit=max&auto=format&n=7-hZ4AEh99NJJtEC&q=85&s=05fc13d665165c06978605139bdb0a63" width="3600" height="2400" data-path="images/97dfe425-group_members_subtitleview_default_web_screens-ed7e2c8f329a2681e1dd06e1d9700139.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/F0pRX00dbgkztAbW/images/114d3fff-group_members_subtitleview_custom_web_screens-0a698b72b22c8ac223f02db596cf13d6.png?fit=max&auto=format&n=F0pRX00dbgkztAbW&q=85&s=1a612a2606906cf5caeb897665e65524" width="3600" height="2400" data-path="images/114d3fff-group_members_subtitleview_custom_web_screens-0a698b72b22c8ac223f02db596cf13d6.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;

      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [subtitleView]="subtitleTemplate"
      ></cometchat-create-group>
    </div>

    <ng-template #subtitleTemplate let-groupMember>
      <div
        style="display: flex; align-items: left; padding: 10px; font-size: 10px;"
      >
        your custom subtitle view
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### TailView

You can customize the tail view for each group members to meet your requirements

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/4xujL4pc0yDqaECl/images/d3af363a-group_members_tailview_default_web_screens-16df8485b0b6c03b4ddf58eef9487d64.png?fit=max&auto=format&n=4xujL4pc0yDqaECl&q=85&s=f55998534e2fbfe90402362abacbe0cd" width="3600" height="2400" data-path="images/d3af363a-group_members_tailview_default_web_screens-16df8485b0b6c03b4ddf58eef9487d64.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/2U5tVIzH12dbbFtr/images/ad4e8cf3-group_members_tailview_custom_web_screens-dd072f924cce0e2cfd870de378963df5.png?fit=max&auto=format&n=2U5tVIzH12dbbFtr&q=85&s=523a9d534bf61a4d7ceb3e1110b96efc" width="3600" height="2400" data-path="images/ad4e8cf3-group_members_tailview_custom_web_screens-dd072f924cce0e2cfd870de378963df5.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;

      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [tailView]="tailViewTemplate"
      ></cometchat-create-group>
    </div>

    <ng-template #tailViewTemplate let-groupMember>
      <div
        [ngStyle]="{
        color: '#5a00a8',
        border: '1px solid #5a00a8',
        borderRadius: '12px',
        padding: '5px'
      }"
      >
        {{ groupMember.getScope() }}
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### EmptyStateView

You can set a custom `EmptyStateView` using `emptyStateView` to match the empty view of your app.

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/SNc1XUNfZQ5aQj_q/images/ff387d20-group_members_empty_stateview_default_web_screens-89587f3bfc14a6d794cc18e45257e9b4.png?fit=max&auto=format&n=SNc1XUNfZQ5aQj_q&q=85&s=a76d0369c06744261ffa8be4b34a87c9" width="3600" height="2400" data-path="images/ff387d20-group_members_empty_stateview_default_web_screens-89587f3bfc14a6d794cc18e45257e9b4.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/KVBs_L3B6NmQumhv/images/0a04ec4f-group_members_empty_stateview_custom_web_screens-3c40c4e92a0db1e7140ec7254334a546.png?fit=max&auto=format&n=KVBs_L3B6NmQumhv&q=85&s=6b9b94122a2b7733ae0f3b468c134086" width="3600" height="2400" data-path="images/0a04ec4f-group_members_empty_stateview_custom_web_screens-3c40c4e92a0db1e7140ec7254334a546.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;

      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [emptyStateView]="emptyStateView"
      ></cometchat-create-group>
    </div>

    <ng-template #emptyStateView>
      <div>Your Custom Empty State</div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### ErrorStateView

You can set a custom `ErrorStateView` using `errorStateView` to match the error view of your app.

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/bKHmaxDqzaJZWwLS/images/47d3da72-group_members_error_stateview_default_web_screens-0fc50b78d3a4f6c5652a9b1e905818f1.png?fit=max&auto=format&n=bKHmaxDqzaJZWwLS&q=85&s=a328c7d848eae6e2ff258e24ba983919" width="3600" height="2400" data-path="images/47d3da72-group_members_error_stateview_default_web_screens-0fc50b78d3a4f6c5652a9b1e905818f1.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/dDWpooIQ48haNjyU/images/79de2c4b-group_members_error_stateview_custom_web_screens-92c528d899e2c86d782e2a5d5848213f.png?fit=max&auto=format&n=dDWpooIQ48haNjyU&q=85&s=26a6aab1176f1433d490a038b8c3ac90" width="3600" height="2400" data-path="images/79de2c4b-group_members_error_stateview_custom_web_screens-92c528d899e2c86d782e2a5d5848213f.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;

      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [errorStateView]="errorStateView"
      ></cometchat-create-group>
    </div>
    <ng-template #errorStateView>
      <div style="height: 100vh; width: 100vw">
        <img
          src="icon"
          alt="error icon"
          style="height:100px; width: 100px; justify-content: center; margin-top: 250px; margin-right: 700px;"
        />
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### Menus

You can set the Custom Menu view to add more options to the Group Members component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/tI1D0nyKUVcz2LEZ/images/c33a0afe-group_members_menus_web_screens-460e3723881237df66214c3e5aaae06c.png?fit=max&auto=format&n=tI1D0nyKUVcz2LEZ&q=85&s=de2402f840d0e2cb39fe2b84609fb34b" width="3600" height="2400" data-path="images/c33a0afe-group_members_menus_web_screens-460e3723881237df66214c3e5aaae06c.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;

      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      handleReload(): void {
        window.location.reload();
      }

      getButtonStyle() {
        return {
          height: '20px',
          width: '20px',
          border: 'none',
          borderRadius: '0',
          background: 'transparent'
        };
      }
      getButtonIconStyle() {
        return {
          color: '#7E57C2'
        };
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [menu]="menuTemplate"
      ></cometchat-create-group>
    </div>
    <ng-template #menuTemplate>
      <div style="margin-right: 20px;">
        <button [ngStyle]="getButtonStyle()" (click)="handleReload()">
          <img src="icon" [ngStyle]="getButtonIconStyle()" alt="Reload Icon" />
        </button>
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### Options

You can set the Custom options to the Group Members component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/tiy_c-4NywbKIGIr/images/7cfb3141-group_members_options_web_screens-511f7e92c96d1f252461f3b5d6f63828.png?fit=max&auto=format&n=tiy_c-4NywbKIGIr&q=85&s=30eef5496cff66bb5253c0086bcc7e3b" width="3600" height="2400" data-path="images/7cfb3141-group_members_options_web_screens-511f7e92c96d1f252461f3b5d6f63828.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { CometChatOption } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;

      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      getOptions = (user: any) => {
        const customOptions = [
          new CometChatOption({
            id: "1",
            title: "Title",
            iconURL: "icon",
            backgroundColor: "red",
            onClick: () => {
              console.log("Custom option clicked for user:", user);
            },
          }),
        ];
        return customOptions;
      };

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-create-group
        [group]="groupObject"
        [options]="getOptions"
      ></cometchat-create-group>
    </div>
    ```
  </Tab>
</Tabs>

***
